package com.yongqi.xinrenli.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import com.yongqi.xinrenli.domain.bo.DbCouponBo;
import com.yongqi.xinrenli.domain.vo.DbCouponVo;
import com.yongqi.xinrenli.domain.DbCoupon;
import com.yongqi.xinrenli.mapper.DbCouponMapper;
import com.yongqi.xinrenli.service.IDbCouponService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 优惠卷Service业务层处理
 *
 * @author zyf
 * @date 2023-03-09
 */
@RequiredArgsConstructor
@Service
public class DbCouponServiceImpl implements IDbCouponService {

    private final DbCouponMapper baseMapper;

    /**
     * 查询优惠卷
     */
    @Override
    public DbCouponVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 查询优惠卷列表
     */
    @Override
    public TableDataInfo<DbCouponVo> queryPageList(DbCouponBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<DbCoupon> lqw = buildQueryWrapper(bo);
        Page<DbCouponVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询优惠卷列表
     */
    @Override
    public List<DbCouponVo> queryList(DbCouponBo bo) {
        LambdaQueryWrapper<DbCoupon> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<DbCoupon> buildQueryWrapper(DbCouponBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<DbCoupon> lqw = Wrappers.lambdaQuery();
        lqw.eq(StringUtils.isNotBlank(bo.getCouponType()), DbCoupon::getCouponType, bo.getCouponType());
        lqw.eq(StringUtils.isNotBlank(bo.getFullSubtraction()), DbCoupon::getFullSubtraction, bo.getFullSubtraction());
        lqw.eq(bo.getMinUsed() != null, DbCoupon::getMinUsed, bo.getMinUsed());
        lqw.eq(bo.getEffectiveTime() != null, DbCoupon::getEffectiveTime, bo.getEffectiveTime());
        lqw.eq(bo.getFailureTime() != null, DbCoupon::getFailureTime, bo.getFailureTime());
        lqw.eq(StringUtils.isNotBlank(bo.getCreateUser()), DbCoupon::getCreateUser, bo.getCreateUser());
        lqw.eq(StringUtils.isNotBlank(bo.getModifyUser()), DbCoupon::getModifyUser, bo.getModifyUser());
        lqw.eq(bo.getModifyTime() != null, DbCoupon::getModifyTime, bo.getModifyTime());
        lqw.eq(bo.getDeleteStatus() != null, DbCoupon::getDeleteStatus, bo.getDeleteStatus());
        return lqw;
    }

    /**
     * 新增优惠卷
     */
    @Override
    public Boolean insertByBo(DbCouponBo bo) {
        DbCoupon add = BeanUtil.toBean(bo, DbCoupon.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改优惠卷
     */
    @Override
    public Boolean updateByBo(DbCouponBo bo) {
        DbCoupon update = BeanUtil.toBean(bo, DbCoupon.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(DbCoupon entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 批量删除优惠卷
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
